<?php
	// DISPLAY ERRORS BUT HIDE NOTICES
	error_reporting(E_ALL ^ E_NOTICE);

	session_start();

	// SET HEADERS TO PREVENT BROWSER CACHING OF PAGES
	@header('Expires: Mon, 20 Jul 2000 05:00:00 GMT');
	@header('Last-Modified: '. gmdate('D, d M Y H:i:s') .' GMT');
	@header('Cache-Control: no-store, no-cache, must-revalidate');
	@header('Cache-Control: post-check=0, pre-check=0', false);
	@header('Pragma: no-cache');

	// MAKE NEW DATABASE OBJECT
	include('includes/mg2_functions.php');
	include('includes/mg2admin_functions.php');
	$mg2 = new MG2admin;

	// DISPLAY ADMIN HEADER
	define('DATA_FOLDER',  dirname(__FILE__) .'/data/');
	define('ADMIN_FOLDER', 'admin/');

	$mg2->gallerytitle = 'Update to kh_mod 0.2.4';
	@include(ADMIN_FOLDER .'admin_header.php');
?>

	<table class="table_menu" cellpadding="0" cellspacing="0">
	<tr valign="top">
		<td align="center" colspan="4">
			<p><strong>Update from MG2 0.5.0/0.5.1 or kh_mod &lt; 0.2.4</strong></p>
			<p>This script will update your gallery to kh_mod 0.2.4 in 2 easy steps.</p>
<?php
	$mg2_settings = (is_file(DATA_FOLDER .'mg2_settings.php'))?
						 DATA_FOLDER .'mg2_settings.php'
						 :
						 'mg2_settings.php';
	if (is_readable($mg2_settings) && include($mg2_settings)) {
		if(empty($_REQUEST['step']) || empty($_SESSION['updatepwd'])) {
			$step = '1';
			if (empty($_POST['password']) ||
				 $mg2->password !== md5(strrev(md5($_POST['password'])))
				)
			{
				// ASK FOR PASSWORD
				inputpassword($mg2);
				exit();
			}
			$_SESSION['updatepwd'] = md5(strrev(md5($_POST['password'])));
			echo '<p><strong>Step '. $step .' / 2</strong></p>';

			if (!isset($mg2->foldersort))	$mg2->foldersort  = 0;				// sort by filename
			if (!isset($mg2->thumbwidth))	$mg2->thumbwidth  = "150";			// thumb max. width
			if (!isset($mg2->thumbheight))$mg2->thumbheight = "150";			// thumb max. height
			if (!isset($mg2->imagefolder))$mg2->imagefolder = "pictures";	// image folder
			if (!isset($mg2->navtype))		$mg2->navtype		= "1";			// navigationstyp (Text, Icons, Thumbs)
			if (!isset($mg2->commentsets))$mg2->commentsets = 7;				// comment settings
			if (!isset($mg2->accesstime))	$mg2->accesstime	= "15";			// auto logout after 15 min.
			if (!isset($mg2->introwidth))	$mg2->introwidth	= "0";			// width of folder intro text
			if (!isset($mg2->metaseting))	$mg2->metaseting	= 17;				// html page titel (meta-tag)

			// PERMISSION TEST, kh_mod 0.2.0, changed
			$error_message = '';
			@rmdir(DATA_FOLDER .'x');
			if (@mkdir(DATA_FOLDER .'x')) {
				@rmdir(DATA_FOLDER .'x');
			} else {
				$error_message.= 'ERROR: Cannot write to \''.DATA_FOLDER.'\' folder.
										Chmod the folder to 777 and try it again!<br />';
			}
			@rmdir($mg2->imagefolder.'/x');
			if (@mkdir($mg2->imagefolder.'/x')) {
				@rmdir($mg2->imagefolder.'/x');
			} else {
				$error_message.= 'ERROR: Cannot write to \''.$mg2->imagefolder.'\' folder.
										Chmod the folder to 777 and try it again!<br />';
			}
			if ($error_message != '') {
				echo $error_message .'
					<br />
					<form action="'. $PHP_SELF .'" method="post">
					<input type="hidden" name="step" value="" />
					<input type="image" src="'. ADMIN_FOLDER .'images/rebuild.gif" class="adminpicbutton" alt="Try it again" title="Try it again" />
					</form>
					<br />&nbsp;
					</td></tr></table></body></html>
				';
				exit();
			}

			// DISPLAY EXIF INFOS, kh_mod 0.2.0, add
			if ($mg2->showexif === '1') $mg2->showexif = 510;

			// FOLDER SETTINGS, kh_mod 0.2.0, add
			if (!isset($mg2->folderseting)) {
				$mg2->folderseting  = $mg2->foldersort & 15;
				$mg2->folderseting |= ($mg2->foldericons)? 16:0;
				$mg2->folderseting |= ($mg2->displayfile)? 32:0;
			}

			// EXTENDED SETTINGS, kh_mod 0.2.0, add
			if (!isset($mg2->extendedset))$mg2->extendedset	= 28;
			elseif (!is_file(DATA_FOLDER .'mg2_settings.php')) {	// 0.2.0 b1 <= kh_mod or MG2 0.5.1/0.5.0
				$mg2->extendedset = (int)$mg2->extendedset | 16;	// update calendar
				$mg2->extendedset^= 1;										//  change bit 1 (password recursiv)
			}

			// UPDATE FOR DATE FORMAT, BUILT IN kh_mod 0.1.0 final
			// kh_mod, 0.3.0 b5, changed
			if (empty($mg2->dateformat)) $mg2->dateformat = '%d.%m.%Y';
			if ($_SESSION['version'] < 2)
			if (substr_count($mg2->dateformat, '%') < 2) {
				$search  = array('%','M','j','i','n','a','A','D','m','d','H','y','Y');					// 13 items
				$replace = array('%%','%b','%e','%M','%n','%p','%p','%a','%m','%d','%H','%y','%Y');	// 13 items
				$mg2->dateformat = str_replace($search,$replace,$mg2->dateformat);
			}

			$filebuffer = "<?php\n";
			$filebuffer.= '$mg2->gallerytitle = '.chr(34).$mg2->gallerytitle.chr(34).";\n";
			$filebuffer.= '$mg2->adminemail = '.chr(34).$mg2->adminemail.chr(34).";\n";
			$filebuffer.= '$mg2->defaultlang = '.chr(34).$mg2->defaultlang.chr(34).";\n";
			$filebuffer.= '$mg2->activeskin = '.chr(34).$mg2->activeskin.chr(34).";\n";
			$filebuffer.= '$mg2->dateformat = '.chr(34).$mg2->dateformat.chr(34).";\n";
			$filebuffer.= '$mg2->navtype = '.chr(34).$mg2->navtype.chr(34).";\n";
			$filebuffer.= '$mg2->foldersort = '.chr(34).$mg2->foldersort.chr(34).";\n";
			$filebuffer.= '$mg2->showexif = '. (int)$mg2->showexif .";\n";
			$filebuffer.= '$mg2->marknew = '.chr(34).$mg2->marknew.chr(34).";\n";
			$filebuffer.= '$mg2->copyright = '.chr(34).$mg2->copyright.chr(34).";\n";
			$filebuffer.= '$mg2->password = '.chr(34).$mg2->password.chr(34).";\n";
			$filebuffer.= '$mg2->extensions = '.chr(34).$mg2->extensions.chr(34).";\n";
			$filebuffer.= '$mg2->mediumimage = '.chr(34).$mg2->mediumimage.chr(34).";\n";
			$filebuffer.= '$mg2->introwidth = '.chr(34).$mg2->introwidth.chr(34).";\n";
			$filebuffer.= '$mg2->indexfile = '.chr(34).$mg2->indexfile.chr(34).";\n";
			$filebuffer.= '$mg2->imagefolder = '.chr(34).$mg2->imagefolder.chr(34).";\n";
			$filebuffer.= '$mg2->folderseting = '. (int)$mg2->folderseting .";\n";
			$filebuffer.= '$mg2->thumbquality = '.chr(34).$mg2->thumbquality.chr(34).";\n";
			$filebuffer.= '$mg2->thumbwidth = '.chr(34).$mg2->thumbwidth.chr(34).";\n";
			$filebuffer.= '$mg2->thumbheight = '.chr(34).$mg2->thumbheight.chr(34).";\n";
			$filebuffer.= '$mg2->commentsets = '. (int)$mg2->commentsets .";\n";
			$filebuffer.= '$mg2->metaseting = '. (int)$mg2->metaseting .";\n";
			$filebuffer.= '$mg2->imagecolumns = '. (int)$mg2->imagecolumns .";\n";
			$filebuffer.= '$mg2->imagerows = '. (int)$mg2->imagerows .";\n";
			$filebuffer.= '$mg2->slideshowdelay = '. (int)$mg2->slideshowdelay .";\n";
			$filebuffer.= '$mg2->websitelink = '.chr(34).$mg2->websitelink.chr(34).";\n";
			$filebuffer.= '$mg2->websitetext = '.chr(34).$mg2->websitetext.chr(34).";\n";
			$filebuffer.= '$mg2->accesstime = '.chr(34).$mg2->accesstime.chr(34).";\n";
			$filebuffer.= '$mg2->extendedset = '. (int)$mg2->extendedset .";\n";
			$filebuffer.= '$mg2->installdate = '.chr(34).$mg2->installdate.chr(34).";\n";
			$filebuffer.= '?>';
			$fd = fopen(DATA_FOLDER .'mg2_settings.php','w');
			$update_ok = fwrite($fd,$filebuffer);
			fclose($fd);

			echo ($update_ok)?
				'Your gallery settings now are upgraded to MG2 0.5.1 (kh_mod 0.2.4)
				<br /><br />
				<form action="'. $_SERVER['PHP_SELF'] .'" method="post">
					<input type="hidden" name="password" value="'.$_POST['password'].'" />
					<input type="hidden" name="step" value="2" />
					<input type="image" src="'. ADMIN_FOLDER .'images/ok.gif" class="adminpicbutton" alt="Next" title="Next" />
				</form>'
				:
				'Couldn\'t upgrade your MG2 settings to MG2 0.5.1 (kh_mod 0.2.4)!
				<br /><br />
				<form action="'. $_SERVER['PHP_SELF'] .'" method="post">
					<input type="hidden" name="step" value="" />
					<input type="image" src="'. ADMIN_FOLDER .'images/rebuild.gif" class="adminpicbutton" alt="Try it again" title="Try it again" />
				</form>';
		} // END OF STEP 1
	} else {
		echo '
			<br />
			ERROR: Cannot read \'mg2_settings.php\' to update your MG2 installation!
			<br /><br />
			<form action="'. $_SERVER['PHP_SELF'] .'" method="post">
			<input type="hidden" name="step" value="" />
			<input type="image" src="'. ADMIN_FOLDER .'images/rebuild.gif" class="adminpicbutton" alt="Try it again" title="Try it again" />
			</form>
		';
	}

	if ($_REQUEST['step'] == '2' && $_SESSION['updatepwd'] == $mg2->password) {
		$step = '2';
		echo '
			<p><strong>Step '. $step .'/2 for MG2 0.5.1/kh_mod 0.1.0 or 0.2.0 b1 <span style="color:red">ONLY!</span></strong></p>
			<form action="'. $_SERVER['PHP_SELF'] .'" method="post">
			<input type="hidden" name="step" value="3" />
			<table cellpadding="0" cellspacing="0" border="0">
				<tr>
					<td>
						<input type="checkbox" name="fDB" id="fDB" value="on" style="vertical-align:middle;" checked="checked" />
						<label for="fDB"> Import folder database (from gallery root)</label>
					</td>
				</tr><tr>
					<td>
						<input type="checkbox" name="iDB" id="iDB" value="on" style="vertical-align:middle;" checked="checked" />
						<label for="iDB"> Import image database (from gallery root)</label>
					</td>
				</tr><tr>
					<td>
						<input type="checkbox" name="log" id="log" value="on" style="vertical-align:middle;" checked="checked" />
						<label for="log"> Import gallery log file (from gallery root)</label>
					</td>
				</tr><tr>
					<td>
						<input type="checkbox" name="cmf" id="cmf" value="on" style="vertical-align:middle;" checked="checked" />
						<label for="cmf"> Convert comment entries (in \''.$mg2->imagefolder.'\')</label>
					</td>	
				</tr>
			</table>
			<br />
			<input type="image" src="'. ADMIN_FOLDER .'images/ok.gif" class="adminpicbutton" alt="Next" title="Next" />
			<a href="'. $_SERVER['PHP_SELF'] .'?step=3"><img src="'. ADMIN_FOLDER .'images/cancel.gif" class="adminpicbutton" alt="'. $mg2->lang['cancel'] .'" title="'. $mg2->lang['cancel'] .'" /></a>
			</form>
		';
	} // END OF STEP 2

	if ($_REQUEST['step'] == '3' && $_SESSION['updatepwd'] == $mg2->password) {
		$step = '3';
		if (is_readable('includes/mg2admin_convert.php')) {
			include('includes/mg2admin_convert.php');
			if (isset($_REQUEST['iDB'])&&$_REQUEST['iDB']=='on') convert_iDB();	// image database
			if (isset($_REQUEST['fDB'])&&$_REQUEST['fDB']=='on') convert_fDB();	// folder database
			if (isset($_REQUEST['log'])&&$_REQUEST['log']=='on') {					// logfile
				$message = (@copy('mg2_log.txt', DATA_FOLDER .'mg2_log.txt'))?
							  'Imoprted log file'
							  :
							  'Couldn\'t imoprt log file';
				$mg2->displaystatus($message);
			}
			if (isset($_REQUEST['cmf'])&&$_REQUEST['cmf']=='on') convert_cmf();	// comment files
			echo '
				<br />
				Your gallery should now be upgraded to MG2 0.5.1 (kh_mod 0.2.4)
				<br /><br />
				- <b>IMPORTANT: DELETE \'mg2_update.php\' USING FTP NOW!!!</b><br />&nbsp;
				<br />
				<p><a href="admin.php">Go to admin panel</a></p>
			';
			unset($_SESSION['updatepwd']);
		}
		else {
			echo '
				<br />
				<b>Couldn\'t upgrade your MG2 installation to MG2 0.5.1 (kh_mod 0.2.4)!</b>
				<br /><br />
				- The convert file \'includes/mg2admin_convert.php\' isn\'t readable.
				<br /><br />
				<form action="'. $_SERVER['PHP_SELF'] .'" method="post">
					<input type="hidden" name="step" value="2" />
					<input type="image" src="'. ADMIN_FOLDER .'images/rebuild.gif" class="adminpicbutton" alt="Try it again" title="Try it again" />
				</form>
			';
		}
	} // END OF STEP 3
?>
		</td>
	</tr>
</table>
</body>
</html>

<?php
	function inputpassword($mg2) {
		if (!is_readable('lang/'.$mg2->defaultlang))	$mg2->defaultlang = 'english.php';
		if (is_readable('lang/'.$mg2->defaultlang)) {
			include('lang/'.$mg2->defaultlang);
			@header('Content-Type: text/html; charset='.$mg2->charset);
		}

		echo'
		<table class="table_menu" cellpadding="0" cellspacing="0">
			<tr>
			<td class="td_div">
				<br />
				<form name="login" method="post" action="'. $_SERVER['PHP_SELF'] .'">
				<p><b>'. $mg2->lang['enterpassword'] .'</b></p>
				<p>'. $mg2->lang['thissection'] .'</p>
				<p><input type="password" name="password" class="admintext" /></p>
				<p><input type="image" src="'. ADMIN_FOLDER .'images/ok.gif" class="adminpicbutton" alt="'. $mg2->lang['ok'] .'" title="'. $mg2->lang['ok'] .'" /></p>
				</form>
			</td>
		</tr>
		</table>
		</body>
		</html>
		';
	}
?>